package com.ruoyi.file.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.file.service.FileUploadResponse;
import com.ruoyi.file.service.Files;
import com.ruoyi.file.service.FilesService;
import com.usky.common.core.bean.ApiResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDateTime;

@RestController
//@RequestMapping("/files")
public class FilesController {

    @Autowired
    private FilesService filesService;

    @PostMapping("/upload")
    public R<FileUploadResponse> upload(@RequestParam MultipartFile file) {
        // 获取上传文件
        FileUploadResponse response = filesService.upload(file);
        return R.ok(response);
    }

    @GetMapping("/download/{filesUUID}")
    public void download(@PathVariable String filesUUID, HttpServletResponse response) {
        //下载文件
        filesService.download(filesUUID, response);
    }


    @DeleteMapping("/delete/{filesUUID}")
    public R<Void> delete(@PathVariable String filesUUID) {
        try {
            filesService.deleteFile(filesUUID);
            return R.ok();
        } catch (Exception e) {
            return R.fail(e.getMessage()); // 删除失败，返回错误信息
        }
    }

    @GetMapping("/query")
    public R<Page<Files>> queryFiles(
            @RequestParam(required = false) String filesName,
            @RequestParam(required = false) LocalDateTime startTime,
            @RequestParam(required = false) LocalDateTime endTime,
            @RequestParam(required = false) Boolean isDeleted,
            @RequestParam(required = false) String fileType,
            @RequestParam int current,
            @RequestParam int size) {

        Page<Files> page = new Page<>(current, size);
        Page<Files> resultPage = filesService.queryFiles(filesName, startTime, endTime, isDeleted, fileType, page);
        return R.ok(resultPage);
    }
}